

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 8000000; _delay_ms 262.14ms/F_CPU(8)  = 32.75ms; _delay_us 768us/F_CPU = 96us */

#include "teplo_di3k.h"

/*
8000000 Mhz  RC
*/


ISR(SIG_INTERRUPT0)
{
//  
	flag&=~ _no_seth;
	SFIOR|=BIT(PSR10);// Bit 0  PSR10: Prescaler Reset Timer/Counter1 and Timer/Counter0
	TCNT0=0;
	flag|=_izm;
	p_step_count=p_step;
	p_step=0;
	//GIFR|=BIT(INTF0);
}

ISR(TIMER0_OVF_vect)//0.000256(256u)
{
static unsigned char nomer_per=0;
unsigned char i=0;
	
	if ( !( flag & _no_seth ) )
	{
	p_step++;

	if (p_step == 3){
		if ( BIT(nomer_per/2) & Pm[power_ten][0] ){	
			PORTDRIVE|=DRIVE_TEN_1;
			i=0x15;
			}
		if ( BIT(nomer_per/2) & Pm[power_ten][1] ){	
			PORTDRIVE|=DRIVE_TEN_2;
			i=0x15;
			}
		if ( BIT(nomer_per/2) & Pm[power_ten][2] ){	
			PORTDRIVE|=DRIVE_TEN_3;
			i=0x15;
			}
		if ( ++nomer_per==32 ) 
				nomer_per=0;
		}
		
	if (power_m)
		if (power_m == p_step) {
			PORTDRIVE|=DRIVE_M;
			i=0x15;
			}
	
	
	if (i){
		while(i) i--;
		//_delay_us(15);
		PORTDRIVE&=~DRIVE_BIT;
		}
	}
}

ISR(TIMER2_OVF_vect){
unsigned char i;
	for(i=0; i<sizeof(time); i++)
		if ( --time[i] == 0 )	time_flag|= BIT(i);
//	if ( --time[0] == 0 )	time_flag|= BIT(0);
//	if ( --time[1] == 0 )	time_flag|= BIT(1);
//	if ( --time[2] == 0 )	time_flag|= BIT(2);
//	if ( --time[3] == 0 )	time_flag|= BIT(3);
}
/*
void USART_Init( void )
{
	//UBRRH = (unsigned char)(baud>>8);//Set baud rate 
	UBRRL = 51;//51;// (unsigned char)baud; //19.2k
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);//Enable receiver and transmitter
	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);//Set frame format: 8data, 2stop bit
}

void USART_Transmit( unsigned char data )
{
	while ( !( UCSRA & (1<<UDRE)) )//Wait for empty transmit buffer
	;
	UDR = data;//Put data into buffer, sends the data
}
*/


void avr_init(void)
{
    // Initialize device here.
	//MCUCR=BIT(ISC01)|BIT(ISC00);//  
	MCUCR=BIT(ISC01);//1 0 The falling edge of INT1 generates an interrupt request.
	GICR=BIT(INT0);//External Interrupt Request 0 Enable
	
	TCCR0=BIT(CS01);
	TCCR2=BIT(CS21);
	TIMSK=BIT(TOIE0)|BIT(TOIE2);
	
	DDRDRIVE|=DRIVE_BIT;
	DDRZN|=BITZN;
	
	PORT_SW|=sw_on_off|sw_12_bit;
	
	//USART_Init();
	sei();

    return;
}
//-------------------EEPROM-------------------------
unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));
	EEAR = uiAddress;
	EECR |= (1<<EERE);
	return EEDR;
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		while(EECR & (1<<EEWE));
		cli();
		EEAR = uiAddress;
		EEDR = ucData;
		EECR |= (1<<EEMWE);
		EECR |= (1<<EEWE);
		sei();
		}
}
//-------------END------EEPROM----------------------

//**********1wire************
void pullup_off(void){
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	PORT_1wire&=~pwire0;
	PORT_1wire&=~pwire1;
}



unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=out_1wire;//line down
	_delay_us(2);//1.2us

	DDR_1wire&=~out_1wire;//line up 
	_delay_us(12);
	i=PIN_1wire;
	sei();
	_delay_us(47);//47
	return i;
}


void readbyte(unsigned char *pw0, unsigned char *pw1) {
unsigned char i,r,p;
*pw0=0;
*pw1=0;
for(i=0, r=1; i<8; i++){
	p=readbit();
	if ( p & pwire0 ) *pw0|=r;
	if ( p & pwire1 ) *pw1|=r;
	r<<=1;	
	}
}


void writebit0(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(60);
	DDR_1wire&=~out_1wire;
	sei();
}

void writebit1(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(3);
	DDR_1wire&=~out_1wire;
	sei();
	_delay_us(57);//57
}

void writebyte(unsigned char byte){
unsigned char i;
	for(i=0; i<8; i++){
		if (byte&BIT(0))
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
}

void detectPresence(void){
unsigned char i;
	
	pullup_off();
	out_1wire=pwire0|pwire1;
	
	DDR_1wire|=pwire0;
	DDR_1wire|=pwire1;
	_delay_ms(0.48);//0.48
	
	cli();
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	_delay_us(60);//60
	i=PIN_1wire;
	sei();
	
	if ( i & pwire0 ) out_1wire&=~pwire0;
	if ( i & pwire1 ) out_1wire&=~pwire1;

	if ( out_1wire == 0 ){
		return;
		}
	
	_delay_ms(0.42);//0.42
	i=PIN_1wire;
	if (!( i & pwire0 )) out_1wire&=~pwire0;
	if (!( i & pwire1 )) out_1wire&=~pwire1;
	
}
//***************************
void scratchpad_save(void){
	detectPresence();
	if (out_1wire){
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
		writebyte(0);//	TH
		writebyte(0);//	TL
		writebyte(0x7f);//	Statys 12bit
		detectPresence();
		if (out_1wire){// EEPROM
			writebyte(0xCC);//SKIP ROM [CCh]
			writebyte(0x48);//COPY SCRATCHPAD [48h]
			PORT_1wire|=pwire0;
			PORT_1wire|=pwire1;
			DDR_1wire|=pwire0;
			DDR_1wire|=pwire1;
			_delay_ms(10);
			pullup_off();
			}
		}
}
//*******end***1wire************

void sinhroseth(void){
	time[_tmp]=50;

	while ( !(flag & _izm) ){
		if (!time[_tmp]){	
			flag|= _no_seth;
			return;
			}
		}
}


void receive_t(unsigned char *t){
unsigned int t0_ds18s20, t1_ds18s20;

	if ( state_wire==0 )
	{
	detectPresence();
	state_wire=1;
	return;
	}
	if ( state_wire==1 )
	{
	if (out_1wire){//
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		PORT_1wire|=pwire0;
		PORT_1wire|=pwire1;
		DDR_1wire|=pwire0;
		DDR_1wire|=pwire1;
		time_wire=20;// 
		state_wire=2;
		//time_flag &=~BIT(_wire1);
		} else state_wire=0;
	return;
	}
	
	if ( state_wire==2 )
	{
	if (!time_wire) state_wire=3;
	return;
	}

	if ( state_wire==3 )
	{
	detectPresence();
	state_wire=4;
	return;
	}
	if ( state_wire==4 )
	{
	if (out_1wire){
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		state_wire=5;
		} else state_wire=0;
	return;
	}	
	if ( state_wire==5 )
	{
		readbyte(t  ,t+2);
		readbyte(t+1,t+3);
		//Tizm[0]=(tempir[0]>>4)|(tempir[1]<<4);//ds18b20
		//Tizm[1]=(tempir[2]>>4)|(tempir[3]<<4);//ds18b20
		t0_ds18s20=(tempir[1]<<8)|tempir[0];
		t1_ds18s20=(tempir[3]<<8)|tempir[2];
		Tizm[0]=(unsigned char)(t0_ds18s20/2);
		Tizm[1]=t1_ds18s20/2;
		state_wire=10;
	}
}

//-------------------------------------
void skan_key(void)
{
unsigned char pin=0;
	key=0;
	PORTZN &= ~BITZN;
	//PORTZN |= BITZN;
	DDRLED=BIT(4);
	PORTLED=~BIT(4);//0xFF;
	_delay_us(40);
	pin=PINLED;
	pin|=BIT(4);
	if ( pin!= 0xFF ){
		//view_zadanie=1;
		time_view_zadanie=30;//*0.05
		if (++anti_dr==15)
			{
			key= ~pin;
			}
		if (anti_dr==btn_speed){
			anti_dr=0;
			if (++n_btn_sp==3) btn_speed=35;
			}
		}
		else{
		btn_speed=200;
		n_btn_sp=0;
		anti_dr=0;
		}
	DDRLED=0xFF;
}
//-------------------------------------
void display(void)
{
	skan_key();
	if ( znmesto==0 )	PORTZN |= ZN0;
	else
	if ( znmesto==1 )	PORTZN |= ZN1;
	else
	if ( znmesto==2 )	PORTZN |= ZN2;
	PORTLED=lcd_buffer[znmesto];
}
//-------------------------------------
void key_action(void)
{
if (key){
	if ( key & btn_plus ){
		if (Tzadanie<100) Tzadanie++;
		view_zadanie=1;
		}
	if ( key & btn_minus ){
		if (Tzadanie) Tzadanie--;
		view_zadanie=1;
		}
	if ( key == btn_state_view ){
		if ( ++view_state==3 ) view_state=0;
		view_zadanie=0;
		}
	EEPROM_write(EEPROM_Tzadanie,Tzadanie);
	}
}
//-------------------------------------
void bcd_num2(char var)
{
unsigned char dig=0;

	while (var >= 10)   {
	 var -= 10;
	 dig ++;
	 }
	lcd_buffer[0]=font[dig];
	lcd_buffer[1]=font[(unsigned char)var];
}
//-------------------------------------
void tempir_error(unsigned char p_wire, unsigned char t){
if ( out_1wire & p_wire )
	{
	bcd_num2(Tizm[t]);
	}
	else
	{
	lcd_buffer[0]=font[f_d];
	lcd_buffer[1]=font[t+1];
	}
}
//------------------------------------
void data_led(void)
{
	lcd_buffer[2]=0xFF;
	if (view_zadanie)
		{
		//bcd_num2(power_m);//!!
		bcd_num2(Tzadanie);
		}
	else
	{
	if ( view_state==2 ){//ds18b20 2
		tempir_error(pwire1,1);
		lcd_buffer[2]=~BIT(2);
		}
	else
	if ( view_state==1 ){//ds18b20 1
		tempir_error(pwire0,0);	
		lcd_buffer[2]=~BIT(1);
		}
	else
	//if ( view_state==0 )//  
		{
		if (flag & _no_seth){
			lcd_buffer[0]=font[f_c];
			lcd_buffer[1]=font[f_u];
			}
		else
		if ( out_1wire == pwire1 ){//   pwire1
			lcd_buffer[0]=font[f_d];
			lcd_buffer[1]=font[1];
			}
		else 
		if ( out_1wire == pwire0 ){
			lcd_buffer[0]=font[f_d];
			lcd_buffer[1]=font[2];
			}
		else
		if ( out_1wire == 0 )		{
			lcd_buffer[0]=font[f_d];
			lcd_buffer[1]=font[f_d];
			}
		else{
			bcd_num2(Tzadanie);
			lcd_buffer[2]=~BIT(0);
			}
		}
		
		
	}
}
//-------------------------------------

int main(void)
{
unsigned char var=0; 
unsigned int  time_motor=10;
    avr_init();
	if ( !(PIN_SW & sw_12_bit) ) scratchpad_save();//12bit

	Tzadanie=EEPROM_read(EEPROM_Tzadanie);
	if ( Tzadanie>80 ) Tzadanie=40;



while(1)
{
	sinhroseth();
	
	receive_t(&tempir[0]);
	time_flag |= BIT(_led);

	while ( (flag & _izm)||(flag & _no_seth) )
	{
	if (flag & _no_seth) {
		receive_t(&tempir[0]);//    
		if ( state_wire==10 ) state_wire=0;
		}

	
	if (flag & _izm)// 
	{
	if ( state_wire==10 )
		{
		state_wire=0;
		//------------Ten-------------------
		if ( Tzadanie >= Tizm[0] ){
			var = Tzadanie-Tizm[0]+1;
			}
			else var=0;
		if  ( var > 14 )//( var > 8 )
			var = 14;//var = 8;
		if ( !(out_1wire & pwire0) ) var = 0;//      
		if ( !(PIN_SW & sw_on_off) ) var = 0;
		power_ten=var;
		//----------------------------------
		
		//------------Moto------------------
		if ( flag & _time_motor ){	
			flag &=~_time_motor ;
			time_motor=5;
			if ( Tizm[0] > Tizm[1] )
				var = (unsigned char)((Tizm[0]-Tizm[1])*3);
				else var=0;
			if  ( var > 34 )
				var = 34;
			if  ( var <= 12 )
				var = 12;
			var =	p_step_count-var;
			//var = 38-var;
			if ( !(PIN_SW & sw_on_off) )	var = 0;
			power_m=var;
			}
		//-----------------------------------
		
		}
	}
	else
	{
	power_ten=0;
	power_m=0;
	PORTDRIVE&=~DRIVE_BIT;
	//time_motor=0;
	}
	if (view_zadanie) if (!time_view_zadanie) view_zadanie=0;
	
	if ( time_flag & BIT(_led) )// 1/8meg * 256*8 = 0,000256 
		{
		time_flag &= ~BIT(_led);
		time[_led]=10;//~0.00
		key_action();
		data_led();
		display();
		if ( ++znmesto==4 )
			{
			znmesto=0;
			flag&=~ _izm;
			}
		}
	if ( time_flag & BIT(_05sek) )
		{
		time_flag &= ~BIT(_05sek);
		time[_05sek]=195;//~0,04992
		time_wire--;
		time_view_zadanie--;
		if (--time_motor==0) flag |= _time_motor;
		}
	}

}

}

/*
if (flag & _izm){
		p+=polupiriod;
		if (++p_usr==200) {
			polu_piriod=p/200;
			p_usr=0;
			p=0;
			}
		}
*/

